#!/usr/bin/python3
# Copyright (C) 2014-2021, Josef Hahn
#
# This file is part of parsley.
#
# parsley is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# parsley is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with parsley.  If not, see <http://www.gnu.org/licenses/>.

import os
import sys
sys.path.append(os.path.abspath(__file__+"/../../.."))
from parsleytest.test import *


class Test(unittest.TestCase):

    def test_main(self):

        setconfig("""<?xml version="1.0" ?>
<parsleyconfig>
    <sync name="test" interval="0s">
        <fs type="MyFilesystem" path="${MYDIR}m" name="master">
            <aspect type="DefaultRemove"/>
        </fs>
        <fs type="MyFilesystem" path="${MYDIR}s" name="slave">
            <aspect type="DefaultRemove"/>
        </fs>
        <aspect type="DefaultSync"/>
        <aspect type="ApplyPathAcceptor" function="mypathacceptor"/>
        <aspect type="Logging" logupdate="1" logcreate="1" logremove="1" />
    </sync>
    <pythonimport importfrom="mymod.MyFilesystemImpl" to="MyFilesystem" />
    <pythonimport importfrom="mymod.mypathacceptorimpl" to="mypathacceptor" />
</parsleyconfig>
        """)

        write2file("m/y", "y")
        write2file("s/x", "x")
        write2file("mymod.py", """
import parsley.filesystem.local
class MyFilesystemImpl(parsley.filesystem.local.LocalFilesystem):
    pass
def mypathacceptorimpl(path,fs):
    return True
        """)

        sys.path.append(mydir)
        SYNC()


if __name__ == '__main__':
    unittest.main()
