# SPDX-FileCopyrightText: © 2014 Josef Hahn
# SPDX-License-Identifier: AGPL-3.0-only

import parsley.aspect.abstractaspect
import parsley.syncengine.common


class DefaultIteration(parsley.aspect.abstractaspect.Aspect):
    """
    Lists child elements via the filesystem.
    Part of parsley.aspect.defaults.DefaultBase.
    """

    @parsley.aspect.hook("", "", "", event=parsley.syncengine.common.SyncEvent.UpdateDir_ListDir)
    def defaultiteration_listdir(self, ctx, filesystem):
        """
        Adds all the child entries to the list (as returned by the underlying filesystem).
        """
        if filesystem.getftype(ctx.path) == parsley.syncengine.common.EntryType.Directory:
            ctx.entrylist.update(filesystem.listdir(ctx.path))
