# SPDX-FileCopyrightText: © 2014 Josef Hahn
# SPDX-License-Identifier: AGPL-3.0-only

import parsley.aspect.abstractaspect
import parsley.runtime.projectinformations
import parsley.syncengine.common


class ReadmeFile(parsley.aspect.abstractaspect.Aspect):
    """
    Writes a readme file into the on-volume parsley control directory.
    """

    # noinspection PyUnusedLocal
    @parsley.aspect.hook("", "", "", event=parsley.syncengine.common.SyncEvent.BeginSync)
    def readmefile_writereadme(self, ctx, filesystem):
        """
        Writes the readme.
        """
        controlfs = filesystem.get_control_filesystem()
        if not controlfs.exists("README"):
            controlfs.writetofile("README", f"This directory structure is synchronized by Parsley.\n"
                                            f"Visit {parsley.runtime.projectinformations.homepage} for more"
                                            f" information.".encode())
