# SPDX-FileCopyrightText: © 2014 Josef Hahn
# SPDX-License-Identifier: AGPL-3.0-only

import parsley.aspect.abstractaspect
import parsley.runtime.datastorage
import parsley.syncengine.common


class VolumePathBreadcrumb(parsley.aspect.abstractaspect.Aspect):
    """
    Writes a file to the data directory that helps finding the sync volumes after runtime.
    """

    @parsley.aspect.hook("", "", "", event=parsley.syncengine.common.SyncEvent.BeginSync)
    def volumepathbreadcrumb_write(self, ctx, filesystem):
        """
        Writes the breadcrumb.
        """
        breadcrumb_storage = parsley.runtime.datastorage.get_storage_department(
            ctx, "volume_path_breadcrumb", location=parsley.runtime.datastorage.StorageLocation.SYSTEM,
            scope=parsley.runtime.datastorage.StorageScope.PER_SYNC)
        breadcrumb_storage.set_value(filesystem.getfulllocalpath("/"), path=filesystem.name)
