# SPDX-FileCopyrightText: © 2014 Josef Hahn
# SPDX-License-Identifier: AGPL-3.0-only

from parsley.gui.helpers import tr
import parsley.gui
import parsley.gui.apidef


# noinspection PyUnusedLocal
@parsley.gui.apidef.registerchangeguide()
def changeguides(cfg, sync):

    def _disable():
        sync.removeaspect("HighLevelCustomization", everywhere=True)
        return True

    def _enable():
        sync.addaspect("HighLevelCustomization")
        parsley.gui.apidef.userfeedback.messagedialog(tr("This option allows you to customize the synchronization"
                                                         " behavior by placing '.parsley.custom.py' script pieces"
                                                         " somewhere in the sync tree. See the documentation for more"
                                                         " details.\n\nFind a sample script in"
                                                         " '_meta/parsley.custom.py.example' inside the Parsley"
                                                         " package."))
        return True

    if sync.hasaspect("HighLevelCustomization", everywhere=True):
        return [(10062, tr("Disable high level customization support"), _disable)]
    else:
        return [(10062, tr("Enable high level customization support"), _enable)]
