# SPDX-FileCopyrightText: © 2014 Josef Hahn
# SPDX-License-Identifier: AGPL-3.0-only

"""
Imports everything that is typically used by the end user in a Parsley config file.
"""

from datetime import timedelta
from parsley.tools.pathacceptors import defaultpathacceptor
from parsley.syncengine.sync import Sync
from parsley.filesystem.local import LocalFilesystem
from parsley.filesystem.sshfs import SshfsFilesystem
from parsley.preparation.mountpreparation import MountPreparation
from parsley.preparation.sshfsmountpreparation import SshfsMountPreparation
from parsley.logger import Logger
from parsley.logger.loggerout.externalprogramloggerout import ExternalProgramLoggerout
from parsley.logger.loggerout.filestreamloggerout import FilestreamLoggerout
from parsley.logger.formatter.plaintextlogformat import PlaintextLogformat
from parsley.logger.formatter.htmllogformat import HtmlLogformat
from parsley.aspect.remove import TrashRemove, DefaultRemove
from parsley.aspect.logging import Logging
from parsley.aspect.defaults import DefaultSync, PullAndPurgeSyncSink, PullAndPurgeSyncSource
from parsley.aspect.revisiontracking import RevisionTracking
from parsley.aspect.applypathacceptor import ApplyPathAcceptor
from parsley.aspect.highlevelcustomization import HighLevelCustomization
from parsley.aspect.monitorfilechanges import MonitorFileChanges
from parsley.tools.pathacceptors import builtinpathacceptor
from parsley.aspect.metadata import MetadataSynchronization, MetadataSynchronizationWithShadow

try:
    import stat
    from parsley.aspect.permissions import ApplyPermissions
except ImportError:
    pass
